VERSION 5.00
Begin VB.Form frmTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Test"
   ClientHeight    =   5160
   ClientLeft      =   2550
   ClientTop       =   1725
   ClientWidth     =   6405
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5160
   ScaleWidth      =   6405
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   4215
      TabIndex        =   2
      Top             =   4500
      Width           =   1875
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   495
      Left            =   2235
      TabIndex        =   1
      Top             =   4500
      Width           =   1875
   End
   Begin VB.CommandButton cmdTryIt 
      Caption         =   "Try It"
      Height          =   495
      Left            =   255
      TabIndex        =   0
      Top             =   4500
      Width           =   1875
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type StateRecord
    StateAbbrev  As String
    StateName    As String
End Type

Dim maudtStateRecord()  As StateRecord

Private Sub Form_Load()

    Dim intStateFileNbr As Integer
    Dim intStateUB      As Integer
    Dim strBS           As String
    
    strBS = IIf(Right$(App.Path, 1) = "\", "", "\")
    intStateFileNbr = FreeFile
    
    intStateUB = -1
    
    Open (App.Path & strBS & "STATES.DAT") For Input As #intStateFileNbr
    
    Do Until EOF(intStateFileNbr)
        intStateUB = intStateUB + 1
        ReDim Preserve maudtStateRecord(0 To intStateUB)
        With maudtStateRecord(intStateUB)
            Input #intStateFileNbr, .StateAbbrev, .StateName
        End With
    Loop

End Sub

Private Sub cmdClear_Click()
    Cls
End Sub


Private Sub cmdExit_Click()
    End
End Sub


Private Sub cmdTryIt_Click()

    Dim strTestAbbrev  As String
    Dim strTestName    As String

    strTestAbbrev = UCase$(InputBox("Enter a state abbreviation.", _
                                    "State Lookup Test"))
    
    strTestName = GetStateName(strTestAbbrev)
    
    Print
    If strTestName = "" Then
        Print "No state name found for '" & strTestAbbrev & "'."
    Else
        Print "'" & strTestAbbrev & "' is the abbreviation for '" _
            & strTestName & "'."
    End If
    
End Sub


Private Function GetStateName(pstrTestAbbrev As String) As String

    Dim intMinIndex     As Integer
    Dim intMaxIndex     As Integer
    Dim intMidIndex     As Integer
    
    intMinIndex = 0
    intMaxIndex = UBound(maudtStateRecord)
    
    Do While intMinIndex <= intMaxIndex
        intMidIndex = Int((intMinIndex + intMaxIndex) / 2)
        If pstrTestAbbrev < maudtStateRecord(intMidIndex).StateAbbrev Then
            intMaxIndex = intMidIndex - 1
        ElseIf pstrTestAbbrev > maudtStateRecord(intMidIndex).StateAbbrev Then
            intMinIndex = intMidIndex + 1
        Else
            ' we have a match
            GetStateName = maudtStateRecord(intMidIndex).StateName
            Exit Function
        End If
    Loop
        
    ' if we get here, the state was not found ...
    GetStateName = ""

End Function



